--
-- ReversingCamera
-- You can look back throw the left window when you are reversing with truck and trailer.
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0 - 2017-09-11 -
--				v1.1 - 2017-09-15 - added controls for position of reverse camera
-- 
SpecializationUtil.registerSpecialization("ReversingCamera", "ReversingCamera", g_currentModDirectory.."ReversingCamera.lua");

ReversingCamera_register = {};
ReversingCamera_register.modDir = g_currentModDirectory;

function ReversingCamera_register:loadMap(name)
	if self.firstRun == nil then
		self.firstRun = false;
		print("ReversingCamera mod loaded")
		
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil then
				local allowInsertion = true;
				for i = 1, table.maxn(v.specializations) do
					local vs = v.specializations[i];
					if vs ~= nil and vs == SpecializationUtil.getSpecialization("drivable") then
						local v_name_string = v.name 
						local point_location = string.find(v_name_string, ".", nil, true)
						if point_location ~= nil then
							local _name = string.sub(v_name_string, 1, point_location-1);
							if rawget(SpecializationUtil.specializations, string.format("%s.ReversingCamera", _name)) ~= nil then
								allowInsertion = false;								
							end;							
						end;
						if allowInsertion then
							table.insert(v.specializations, SpecializationUtil.getSpecialization("ReversingCamera"));
							g_i18n.globalI18N.texts["revCamOut"] = g_i18n:getText("revCamOut")
							g_i18n.globalI18N.texts["revCamIn"] = g_i18n:getText("revCamIn")
							g_i18n.globalI18N.texts["revCamForward"] = g_i18n:getText("revCamForward")
							g_i18n.globalI18N.texts["revCamBack"] = g_i18n:getText("revCamBack")
							g_i18n.globalI18N.texts["revCamReset"] = g_i18n:getText("revCamReset")
							g_i18n.globalI18N.texts["revCamHelpShow"] = g_i18n:getText("revCamHelpShow")
							g_i18n.globalI18N.texts["revCamHelpHide"] = g_i18n:getText("revCamHelpHide")
							allowInsertion = false;
						end;
					end;
				end;
			end;	
		end;
	end;
end;
function ReversingCamera_register:deleteMap()
end;
function ReversingCamera_register:keyEvent(unicode, sym, modifier, isDown)
end;
function ReversingCamera_register:mouseEvent(posX, posY, isDown, isUp, button)
end;
function ReversingCamera_register:update(dt)
end;
function ReversingCamera_register:draw()
end;

addModEventListener(ReversingCamera_register);
